<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>postgreSQL-primer</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h2 id="installation">Installation</h2>
    <ol type="1">
      <li>
        <p>Install Postgres and a simple UI</p>
        <div class="sourceCode" id="cb1">
          <pre
            class="sourceCode bash"
          ><code class="sourceCode bash"><a class="sourceLine" id="cb1-1" title="1"><span class="ex">brew</span> install postgresql</a>
<a class="sourceLine" id="cb1-2" title="2"><span class="co"># https://youtu.be/xaWlS9HtWYw?list=PL-osiE80TeTsKOdPrKeSOp4rN3mza8VHN&amp;t=192</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="ex">brew</span> cask install psequel</a></code></pre>
        </div>
      </li>
      <li>
        <p>Start Postgres</p>
        <div class="sourceCode" id="cb2">
          <pre
            class="sourceCode bash"
          ><code class="sourceCode bash"><a class="sourceLine" id="cb2-1" title="1"><span class="ex">brew</span> services start postgresql</a></code></pre>
        </div>
      </li>
      <li>
        <p>Initialize the database</p>
        <div class="sourceCode" id="cb3">
          <pre
            class="sourceCode bash"
          ><code class="sourceCode bash"><a class="sourceLine" id="cb3-1" title="1"><span class="ex">createdb</span> sample_db</a>
<a class="sourceLine" id="cb3-2" title="2"><span class="ex">psql</span> sample_db</a></code></pre>
        </div>
      </li>
    </ol>
    <h2 id="creating-the-first-table">Creating the first table</h2>
    <p>
      https://youtu.be/w4HEVY_GjqY?list=PL-osiE80TeTsKOdPrKeSOp4rN3mza8VHN&amp;t=317
    </p>
    <p>
      <a
        href="https://www.postgresql.org/docs/9.5/static/datatype.html#DATATYPE-TABLE"
        >Postgres Dataype Table</a
      >
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb4-1" title="1"><span class="dt">VARCHAR</span>(N) <span class="co">/*Where n is maximum amount of characters that will be stored in the field*/</span></a></code></pre>
    </div>
    <h2 id="delete-a-table">Delete a table</h2>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">DROP</span> <span class="kw">TABLE</span> people</a></code></pre>
    </div>
    <h2 id="populate-data">Populate data</h2>
    <p>https://youtu.be/fA0jpjwi4J8?list=PL-osiE80TeTsKOdPrKeSOp4rN3mza8VHN</p>
    <p>It is possible to insert data with or without fieldnames.</p>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb6-1" title="1"><span class="kw">INSERT</span> <span class="kw">INTO</span> people <span class="kw">VALUES</span> (<span class="dv">3</span>, <span class="st">&#39;Dave&#39;</span>)</a>
<a class="sourceLine" id="cb6-2" title="2"><span class="kw">INSERT</span> <span class="kw">INTO</span> people (<span class="kw">id</span>, name) <span class="kw">VALUES</span> (<span class="dv">3</span>, <span class="st">&#39;Dave&#39;</span>)</a></code></pre>
    </div>
    <h2 id="select-data">SELECT DATA</h2>
    <p>
      https://youtu.be/-FPVPcq28r4?list=PL-osiE80TeTsKOdPrKeSOp4rN3mza8VHN&amp;t=68
    </p>
    <h3 id="get-all-data">Get all data</h3>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb7-1" title="1"><span class="kw">SELECT</span> <span class="op">*</span> <span class="kw">from</span> poeple</a></code></pre>
    </div>
    <h3 id="get-specific-columns">Get specific columns</h3>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb8-1" title="1"><span class="kw">SELECT</span> first_name, age <span class="kw">from</span> poeple</a></code></pre>
    </div>
    <h3 id="multiple-condition-where-statement">
      Multiple condition where statement
    </h3>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb9-1" title="1"><span class="kw">SELECT</span> <span class="op">*</span> <span class="kw">FROM</span> PEOPLEs</a>
<a class="sourceLine" id="cb9-2" title="2"><span class="kw">WHERE</span> last_name <span class="op">=</span> <span class="st">&#39;Backstrom&#39;</span></a>
<a class="sourceLine" id="cb9-3" title="3"><span class="kw">AND</span> age <span class="op">&lt;</span> <span class="dv">37</span></a></code></pre>
    </div>
    <h3 id="order-by">ORDER BY</h3>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">SELECT</span> <span class="op">*</span> <span class="kw">FROM</span> PEOPLE</a>
<a class="sourceLine" id="cb10-2" title="2"><span class="kw">WHERE</span> age <span class="op">&lt;</span> <span class="dv">35</span></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="kw">ORDER</span> <span class="kw">BY</span> age;</a></code></pre>
    </div>
    <p>
      The order will be ascending by default. To revert the order add the
      <code>DESC</code> keyword at the end of the
      <code>ORDER BY</code> statement, like so:
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">SELECT</span> <span class="op">*</span> <span class="kw">FROM</span> PEOPLE</a>
<a class="sourceLine" id="cb11-2" title="2"><span class="kw">WHERE</span> age <span class="op">&lt;</span> <span class="dv">35</span></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="kw">ORDER</span> <span class="kw">BY</span> age <span class="kw">DESC</span>;</a></code></pre>
    </div>
    <p>
      SELECT * FROM PEOPLE WHERE age &lt; 35 ORDER BY Last_name, first_name;
    </p>
    <h3 id="update">Update</h3>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">UPDATE</span> people</a>
<a class="sourceLine" id="cb12-2" title="2"><span class="kw">SET</span> age<span class="op">=</span><span class="dv">37</span></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="kw">WHERE</span> first_name <span class="op">=</span> <span class="st">&#39;Joakim&#39;</span></a></code></pre>
    </div>
    <h3 id="delete">DELETE</h3>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode sql"
      ><code class="sourceCode sql"><a class="sourceLine" id="cb13-1" title="1"><span class="kw">DELETE</span> <span class="kw">FROM</span> people</a>
<a class="sourceLine" id="cb13-2" title="2"><span class="kw">WHERE</span> first_name <span class="op">=</span> <span class="st">&#39;Joakim&#39;</span></a></code></pre>
    </div>
  </body>
</html>
